using System;
using System.Collections.Generic;
using System.Text;

namespace MsCrmHelpers
{
    namespace CrmSdk
    {
        public partial class Key
        {
            public override string ToString()
            {
                return this.Value.ToString("N");
            }
        }

        public partial class contact
        {
            public override string ToString()
            {
                return this.lastname;
            }
        }

        public partial class DynamicEntity
        {
            public Property GetCrmProperty(string propertyName)
            {
                foreach (Property property in this.Properties)
                {
                    if (property.Name.Equals(propertyName, StringComparison.InvariantCultureIgnoreCase))
                        return property;
                }

                return null;
            }
        }

        public partial class StringProperty
        {
            public override string ToString()
            {
                return String.Format("StringProperty: {0}={1}", this.Name, this.Value);
            }
        }

        public partial class UniqueIdentifierProperty
        {
            public override string ToString()
            {
                return String.Format("UniqueIdentifierProperty: {0}={1}", this.Name, this.Value);
            }
        }

        public partial class CustomerProperty
        {
            public override string ToString()
            {
                return String.Format("CustomerProperty: {0}={1}", this.Name, this.Value);
            }
        }

        public partial class UniqueIdentifier
        {
            public override string ToString()
            {
                if (this.IsNull)
                    return "(null)";
                else
                    return this.Value.ToString();
            }
        }

        public partial class CrmNumberProperty
        {
            public override string ToString()
            {
                return String.Format("CrmNumberProperty: {0}={1}", this.Name, this.Value);
            }
        }

        public partial class Lookup
        {
            public override string ToString()
            {
                if (this.IsNull)
                    return "(null)";
                else
                    return this.Value + " (name=" + this.name + ")";
            }
        }

        public partial class CrmNumber
        {
            public override string ToString()
            {
                if (this.IsNull)
                    return "(null)";
                else
                    return this.Value.ToString();
            }
        }

        public partial class CrmDecimal
        {
            public override string ToString()
            {
                if (this.IsNull)
                    return "(null)";
                else
                    return this.Value.ToString();
            }
        }

        public partial class CrmDateTimeProperty
        {
            public override string ToString()
            {
                return String.Format("CrmDateTimeProperty: {0}={1}", this.Name, this.Value);
            }
        }

        public partial class CrmReference
        {
            public override string ToString()
            {
                if (this.IsNull)
                    return "(null)";
                else
                    return this.Value + " (name=" + this.name + ")";
            }
        }

        public partial class CrmDateTime
        {
            public override string ToString()
            {
                return this.Value;
            }
        }

        public partial class CrmDecimalProperty
        {
            public override string ToString()
            {
                return String.Format("CrmDecimalProperty: {0}={1}", this.Name, this.Value);
            }
        }

        public partial class LookupProperty
        {
            public override string ToString()
            {
                return String.Format("LookupProperty: {0}={1}", this.Name, this.Value);
            }
        }

    }
}
