using System;
using System.Collections.Generic;
using System.Text;
using MsCrmHelpers.CrmSdk;

namespace MsCrmHelpers
{
    public class CrmPropertyList: List<Property>
    {
        public CrmPropertyList(Property[] properties)
            : base(properties != null? properties : new Property[0])
        {
        }

        public Property GetProperty(string propertyName)
        {
            foreach (Property property in this)
            {
                if (property.Name.Equals(propertyName, StringComparison.InvariantCultureIgnoreCase))
                    return property;
            }

            return null;
        }
        
        public void SetProperty(Property property)
        {
            for (int i = 0; i < this.Count; i++)
            {
                if (property.Name.Equals(this[i].Name, StringComparison.InvariantCultureIgnoreCase))
                {
                    this[i] = property;
                    return;
                }
            }

            this.Add(property);
        }

    }
}
