
// =====================================================================
//  File:		[FILENAME GOES HERE]
//  Summary:	[FILE DESCRIPTION GOES HERE]
// =====================================================================
//
//  This file is part of the Microsoft CRM V3.0 SDK Code Samples.
//
//  Copyright (C) Microsoft Corporation.  All rights reserved.
//
//  This source code is intended only as a supplement to Microsoft
//  Development Tools and/or on-line documentation.  See these other
//  materials for detailed information regarding Microsoft code samples.
//
//  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
//  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
//  PARTICULAR PURPOSE.
//
// =====================================================================

using System;

namespace Microsoft.Crm.Sdk.Helpers.Collection
{
	/// <summary>
	/// Used by the ColumnSetHelper class to keep track of the columns
	/// </summary>
	/// <remarks>Unlike the other collection classes, this class is used internally</remarks>
	public class ColumnsCollection : System.Collections.CollectionBase
	{
		#region Properties

		internal string this[int index]
		{
			get
			{
				return (string)List[index];
			}
		}

		#endregion

		#region Methods

		internal void AddColumn(string attributeName)
		{
			// add only if the attribute does not already exist in the list
			if (!List.Contains(attributeName))
			{
				List.Add(attributeName);
			}
		}

		internal string[] ToStringArray()
		{
			// initialize an array to the number of columns in the columns collection
			string[] returnArray = new string[List.Count];

			// populate the array
			for (int index = 0; index < returnArray.Length; index++)
			{
				returnArray[index] = (string)List[index];
			}

			return returnArray;
		}

		#endregion
	}
}
