using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Services.Protocols;
using System.Xml;

namespace MsCrmHelpers
{
    public class SoapExceptionParser
    {
        public const uint ObjectNotFound = 0x80040217;

        /// <summary>
        /// Attemptes to extract the error code from a SoapException
        /// </summary>
        /// <param name="soapException"></param>
        /// <returns></returns>
        public static uint ExtractExceptionCode(SoapException soapException)
        {
            XmlNode errorNode = soapException.Detail["error"];
            if (errorNode == null) return 0;

            XmlNode codeNode = errorNode["code"];
            if (codeNode == null) return 0;

            string code = codeNode.InnerText;
            if (!code.StartsWith("0x")) return 0;

            code = code.Substring(2);
            return UInt32.Parse(code, System.Globalization.NumberStyles.HexNumber);
        }
    }
}
