using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;

namespace FastSqlSync
{
    public class DatabaseTable
    {
        private string m_IdColumn;
        public string IdColumn
        {
            get { return m_IdColumn; }
            set { m_IdColumn = value; }
        }

        private string m_TableName;
        public string TableName
        {
            get { return m_TableName; }
            set { m_TableName = value; }
        }

        private string m_EntityName;

        public string EntityName
        {
            get { return m_EntityName; }
            set { m_EntityName = value; }
        }
	
        private string m_DatabaseName;
        public string DatabaseName
        {
            get { return m_DatabaseName; }
            set { m_DatabaseName = value; }
        }

        internal string FullyQualifiedName
        {
            get
            {
                string name = "";
                name += "[" + DatabaseName + "]";
                name += "..";
                name += "[" + TableName + "]";
                return name;
            }
        }

        private SynchonizeDirection m_Direction = SynchonizeDirection.Dual;
        public SynchonizeDirection Direction
        {
            get { return m_Direction; }
            set { m_Direction = value; }
        }

        public DatabaseTable()
        {
        }

        public enum SynchonizeDirection
        {
            Source,
            Dual,
            Target
        }
    }
}
