using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Diagnostics;

namespace FastSqlSync
{
    /// <summary>
    /// A log for errors
    /// </summary>
    public class ProgressLog
    {
        public static ProgressLog Current = new ProgressLog();

        

	
        private int m_ErrorCount;

        public int ErrorCount
        {
            get { return m_ErrorCount; }
        }

        private int m_WarningCount;
        public int WarningCount
        {
            get { return m_WarningCount; }
        }
	
        private StringBuilder m_Log = new StringBuilder();

        public string Log
        {
            get { return m_Log.ToString(); }
        }

        private void WriteLine(string message, string fontColor)
        {
            if (!String.IsNullOrEmpty(fontColor))
                m_Log.Append("<font color=" + fontColor + ">");

            message = HttpUtility.HtmlEncode(message);
            message = message.Replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;");
            m_Log.Append(message);
            
            if (!String.IsNullOrEmpty(fontColor))
                m_Log.Append("</font>");

            m_Log.AppendLine("<br/>");
        }

        public void WriteError(string errorMessage)
        {
            Trace.TraceError(errorMessage);
            WriteLine(errorMessage, "red");
            m_ErrorCount++;
        }

        public void WriteInfo(string infoMessage)
        {
            Trace.TraceInformation(infoMessage);
            WriteLine(infoMessage, null);
        }

        internal void WriteWarning(string warningMessage)
        {
            Trace.TraceInformation(warningMessage);
            WriteLine(warningMessage, "blue");
            m_WarningCount++;
        }


        //private ProgressLogTraceListener m_Listener;

        ///// <summary>
        ///// Flag that indicates whether we are listening to Trace output
        ///// </summary>
        //public bool ListeningToTrace
        //{
        //    get { return (m_Listener != null); }
        //    set 
        //    {
        //        SetListeningToTrace(value);
        //    }
        //}

        //private void SetListeningToTrace(bool newValue)
        //{
        //    if (newValue != ListeningToTrace)
        //    {
        //        if (newValue)
        //        {
        //            m_Listener = new ProgressLogTraceListener(this);
        //            Trace.Listeners.Add(m_Listener);
        //        }
        //        else
        //        {
        //            Trace.Listeners.Remove(m_Listener);
        //        }
        //    }
        //}

        ///// <summary>
        ///// A listener for Diagnostics.Trace events
        ///// </summary>
        //public class ProgressLogTraceListener : TraceListener
        //{
        //    public override void TraceEvent(TraceEventCache eventCache, string source, TraceEventType eventType, int id)
        //    {
        //        TraceEventType.
        //        base.TraceEvent(eventCache, source, eventType, id);
        //    }
        //    public override void Write(string message)
        //    {
        //        throw new Exception("The method or operation is not implemented.");
        //    }

        //    public override void WriteLine(string message)
        //    {
        //        throw new Exception("The method or operation is not implemented.");
        //    }
        //}
    }
}
